# Gero Doose gero@bioinf.uni-leipzig.de
import sys, argparse, subprocess, re
parser = argparse.ArgumentParser(description='script to calculate individual sample support for splice junctions of type normal or circular')
parser.add_argument("-n", "--bed", dest='my_normal_circular_bed', required=True, type=argparse.FileType('r'), help="bed file containing the normal and circular junctions (based on all samples)")
parser.add_argument("-b", "--bam", dest='my_bam', required=True, help="bam file")
parser.add_argument("-m", "--max_range", dest='my_max_range', type=int, help="specifies the maximal distance (default 7) to the exact splice site (due to majority clustering.)")
args = parser.parse_args()
if(args.my_max_range):
    maxRange=args.my_max_range
else:
    maxRange=7

def produce_string(m_chrom, pos_left, pos_rigth):
    my_command_1="samtools view "+args.my_bam+" "+m_chrom+":"+pos_left+"-"+pos_rigth
    my_command_2='fgrep XQ:i:'
    p1 = subprocess.Popen(my_command_1.split(), stdout=subprocess.PIPE)
    p2 = subprocess.Popen(my_command_2.split(),stdin=p1.stdout, stdout=subprocess.PIPE)
    return_string = p2.communicate()[0].strip().split("\n")
    return return_string

class Junction(object):
    chrom=""
    start=0
    end=0
    junctionCounter=0
    j_type=""
    def __init__(self, chrom, start, end, name):
        self.chrom = chrom
        self.start = int(start)
        self.end = int(end)
        fields=name.strip().split(':')
        self.j_type=fields[4]
        
def make_junction(chrom, start, end, name):
    junction=Junction(chrom, start, end, name)
    return junction

myListofJunctions=[]
with args.my_normal_circular_bed as normal_circular_junctions:
    for line in normal_circular_junctions:
        columns = line.strip().split('\t')
        if(columns[0][:1]!="#"):
            myListofJunctions.append(make_junction(columns[0], columns[1], columns[2], columns[3]))

for juncts in myListofJunctions:
    if juncts.j_type=="N":
        split_reads = produce_string(juncts.chrom, str(juncts.end -maxRange), str(juncts.end + maxRange))
    elif juncts.j_type=="C":
        split_reads = produce_string(juncts.chrom, str(juncts.start -maxRange), str(juncts.start + maxRange))
    if split_reads != ['']:
        for split_read in split_reads:
            XV_pos_set=False
            XU_pos_set=False
            columns = split_read.strip().split('\t')
            for i in range(11,(len(columns))):
                if "XT:i:" in columns[i]:
                    XT_pos=int(columns[i][5:])
                if "XS:i:" in columns[i]:
                    XS_pos=int(columns[i][5:])
                if "XV:i:" in columns[i]:
                    XV_pos=int(columns[i][5:])
                    XV_pos_set=True
                if "XU:i:" in columns[i]:
                    XU_pos=int(columns[i][5:])
                    XU_pos_set=True
            if juncts.j_type=="N":
                if (int(columns[3]) <= (juncts.end + maxRange)) and (int(columns[3]) >= (juncts.end -maxRange)):
                    if((int(columns[1]) >= 16 and int(columns[1]) & 16)):
                        if(XV_pos_set):
                            if(XT_pos==0):
                                if (XV_pos >= (juncts.start - maxRange)) and  (XV_pos <= (juncts.start + maxRange)): 
                                    juncts.junctionCounter+=1
                    else:
                        if(XU_pos_set):
                            if(XS_pos==64):
                                if (XU_pos >= (juncts.start - maxRange)) and  (XU_pos <= (juncts.start + maxRange)): 
                                    juncts.junctionCounter+=1
            elif juncts.j_type=="C":
                if (int(columns[3]) <= (juncts.start + maxRange)) and (int(columns[3]) >= (juncts.start -maxRange)):
                    if((int(columns[1]) >= 16 and int(columns[1]) & 16)):
                        if(XV_pos_set):
                            if(XT_pos==0):
                                if (XV_pos >= (juncts.end - maxRange)) and  (XV_pos <= (juncts.end + maxRange)): 
                                    juncts.junctionCounter+=1
                    else:
                        if(XU_pos_set):
                            if(XS_pos==64):
                                if (XU_pos >= (juncts.end - maxRange)) and  (XU_pos <= (juncts.end + maxRange)): 
                                    juncts.junctionCounter+=1
                       
                                                   
for myItems in myListofJunctions:
    seq_header=myItems.chrom+"\t"+str(myItems.start)+"\t"+str(myItems.end)+"\t"+myItems.j_type+"\t"+str(myItems.junctionCounter)+"\t.\n"
    sys.stdout.write(seq_header)
                  
sys.stdout.flush()
sys.stdout.close()